import 'dart:convert';

import 'package:example/models/error_base_model.dart';

class BaseResponseModel<T> {
  T? result;
  ErrorBaseModel? error;
  int? totalCount;
  bool? hasMore;

  BaseResponseModel({
    this.result,
    this.error,
    this.totalCount,
    this.hasMore,
  });
  factory BaseResponseModel.fromRawJson(
          String str, T Function(Map<String, dynamic>) fromJsonT) =>
      BaseResponseModel.fromJson(
          json.decode(str) as Map<String, dynamic>, fromJsonT);

  String toRawJson() => json.encode(toJson());
  factory BaseResponseModel.fromJson(Map<String, dynamic> json,
          T Function(Map<String, dynamic>) fromJsonT) =>
      BaseResponseModel(
        result: json["result"] != null
            ? (json["result"] is List
                ? (json["result"] as List)
                    .map((e) => fromJsonT(e as Map<String, dynamic>))
                    .toList()
                : fromJsonT(json["result"] as Map<String, dynamic>)) as T
            : null,
        error: json["error"] == null
            ? null
            : ErrorBaseModel.fromJson(json["error"]),
        totalCount: json["totalCount"],
        hasMore: json["hasMore"],
      );

  Map<String, dynamic> toJson() => {
        "result": result != null
            ? (result is List
                ? (result as List).map((e) => (e as dynamic)!.toJson()).toList()
                : (result as dynamic)!.toJson())
            : null,
        "error": error,
        "totalCount": totalCount,
        "hasMore": hasMore,
      };
}
