import 'dart:io';
import 'package:example/app/app.dart';
import 'package:example/configs/locator.dart' as locator;
import 'package:flutter/material.dart';
import 'package:flutter_simple_template_bloc/flutter_simple_template_bloc.dart';

void main() async {
  HttpOverrides.global = MyHttpOverrides();
  WidgetsFlutterBinding.ensureInitialized();
  await EasyLocalization.ensureInitialized();
  EasyLocalization.logger.enableBuildModes = [];
  locator.setup();

  runApp(
    EasyLocalization(
      path: 'assets/translations',
      supportedLocales: const [
        Locale('en', 'US'),
        Locale('vi', 'VN'),
      ],
      fallbackLocale: const Locale('en', 'US'),
      child: const MyApp(),
    ),
  );
}
