import 'dart:convert';

class ErrorBaseModel {
  final String? code;
  final String? message;

  ErrorBaseModel({
    this.code,
    this.message,
  });

  factory ErrorBaseModel.fromRawJson(String str) =>
      ErrorBaseModel.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory ErrorBaseModel.fromJson(Map<String, dynamic> json) => ErrorBaseModel(
        code: json["code"]?.toString(),
        message: json["message"],
      );

  Map<String, dynamic> toJson() => {
        "code": code,
        "message": message,
      };
}
