import 'package:example/blocs/demo/demo_bloc.dart';
import 'package:flutter/material.dart';
import 'package:flutter_simple_template_bloc/flutter_simple_template_bloc.dart';

class DemoScreen extends BaseStatelessWidget<DemoBloc, DemoState> {
  const DemoScreen({super.key});

  static Widget provider() {
    return BlocProvider(
      create: (context) => DemoBloc(),
      child: const DemoScreen(),
    );
  }

  @override
  void init(BuildContext context) {
    super.init(context);
    context.read<DemoBloc>().add(DemoInit());
  }

  @override
  Widget builder(BuildContext context, DemoState state) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Flutter simple template'),
        backgroundColor: Colors.blueAccent,
      ),
      body: Center(
        child: Text(state.message),
      ),
    );
  }

  @override
  void listener(BuildContext context, state) {}
}
