import 'package:flutter/material.dart';

class MaterialPageRouteTransition<T> extends MaterialPageRoute<T> {
  MaterialPageRouteTransition({
    required WidgetBuilder builder,
    RouteSettings? settings,
  }) : super(builder: builder, settings: settings);

  @override
  Widget buildTransitions(
    BuildContext context,
    Animation<double> animation,
    Animation<double> secondaryAnimation,
    Widget child,
  ) {
    final Animatable<Offset> tween = Tween(
      begin: const Offset(1.0, 0.0),
      end: Offset.zero,
    ).chain(
      CurveTween(curve: Curves.ease),
    );
    return SlideTransition(
      position: animation.drive(tween),
      child: child,
    );
  }
}
