import 'package:flutter/material.dart';

class AppLifecycleObserver extends WidgetsBindingObserver {
  VoidCallback appPausedEvent;
  VoidCallback appResumedEvent;

  AppLifecycleObserver(
    this.appPausedEvent,
    this.appResumedEvent,
  );

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    if (state == AppLifecycleState.paused) {
      // App goes to background
      debugPrint('========= App goes to background =========');
      appPausedEvent;
    } else if (state == AppLifecycleState.resumed) {
      // App comes to foreground
      debugPrint('========= App comes to foreground =========');
      appPausedEvent;
    }
  }
}
