import 'package:flutter/material.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';

class LoadingWidget extends StatelessWidget {
  final bool isLoading;
  final Widget? kindSpinKit;

  const LoadingWidget({
    super.key,
    required this.isLoading,
    this.kindSpinKit,
  });

  @override
  Widget build(BuildContext context) {
    return isLoading
        ? Positioned.fill(
            child: Align(
              alignment: Alignment.center,
              child: AbsorbPointer(
                child: Container(
                  color: Colors.grey.withOpacity(0.5),
                  alignment: Alignment.center,
                  child: kindSpinKit ??
                      const SpinKitFadingCircle(
                        color: Colors.white,
                      ),
                ),
              ),
            ),
          )
        : const SizedBox.shrink();
  }
}
